#!/usr/bin/perl -w
#  this script read kymesonet daily data from kymesonet database 
#DB:wxdb,TABLE kypmsites(station CHAR(22),ddate INT,tmax INT,tmin INT,precip REAL,type CHAR(1),aeflag CHAR(1))
#please run: ./cal_kymsites_distance.pl site 
# or ./cal_kymsites_distance.pl for all sites
#  WH Wang,20101215
use Math::Trig;


$sdir = "/data/ldm/data/kymesonet/scripts/";
#$ddir = "/data/ldm/data/kyallsites/PM";

# data dir
$kymsites = "kymesonet_sites2";

if ($ARGV[0]){ $input = $ARGV[0]; chomp($input); }
else { print "run: ./cal_kymsites_distance.pl or ./cal_kymsites_distance.pl site\n";   
	     print "For example:./cal_kymsites_distance.pl site  -- for one site\n";	
	     print "or ./cal_kymsites_distance.pl for all sites\n\n";	       
	     #exit;
}

#if ($input =~ /\d+/){  }
#if ($ARGV[0]){ $ddate = $input; }
#else { $ddate = $yesterday; }


#	
&read_kymsites;	
#exit;
#Calculate distance of neast sites for estimating missing data

$k = 0;
foreach $st(@sites){   
	   $lat[$k] = $lat{$st};
	   $lon[$k] = $lon{$st};
	   print "$st,$lat[$k],$lon[$k]\n";
	   
	   
     foreach $co(@sites){
        $lat = $lat{$co};
        $lon = $lon{$co};
        #print "Esimate site: $co,$lat,$lon\n";
	      &cal_distance;       
	      
	   }
	  
	  #@sorted = sort @dists;
	  #print "@sorted\n";
	  
	  @sites1 = @sites;
	  $i = 0;
	  while($i < 5){      
	      &find_neast_sites;      	      
	      if ($neast != 0){ print "The distance from $st to $nco : $neast\n"; }

 	      
 	      @sites2 = "";
 	      $d1 = 0;
        foreach $ss(@sites1){
        	   if ($ss ne $nco){ 
        	   	   if ($d1 == 0){ @sites2 = $ss; $d1 = 1; }
        	   	   else{ push(@sites2,$ss); }
        	   }
        }	
	      	      
	      @sites1 = @sites2;
	      
	      $i++;
	      
	  }
	  
	  #if ($k > 1){ last; }
	  $k++;

	  print "\n";

}


print "Total sites calculated: $k\n";

#

print "\n\n";
#@sorted= sort @sites;
#print "@sorted\n\n";
#foreach $ss(@sorted){ print "$ss\n"; }

##



# read kymesonet_sites file 
sub read_kymsites
{
#COUNTY        SITE TIMEZONE CD LATITUDE LONGITUDE  START     LOCATION
print "Read $kymsites file...\n";

$file = $sdir . $kymsites;

open (INFILE,"$file");

$i = 0;
while (!eof(INFILE)) {
    $line = <INFILE>;
    chomp($line);
    #print "$line\n";
    
    ($co,$sid,$tz,$cd,$lat,$lon,$start,$loc) = split(/\s+/,$line);
    chomp($line);
    
    $loc = trim($loc);    
    $sid = trim($sid);
    $co = trim($co);
    $tz = trim($tz);
    $lat = trim($lat);
    $lon = trim($lon);   
    
    if ($i > 0){
        push(@sites,$co);
    
        $lat{$co} = $lat;
        $lon{$co} = $lon;
    }
    print "$co,$lat,$lon\n";
    
    #$d1 = $data{$co};    
    #$co = sprintf("%-21s",$co);
    #print "$co,$sid,$co,$tz,$lat,$lon\n"; 
    #print "$co,$ddate,$lat,$lon,$d1\n"; 
    #&read_db_data;  	
    
    $i++;     
    
}

close(INFILE);
$i = $i - 1;
print "Total data readed from $kymsites : $i\n\n";

}	

sub cal_distance
{

#sqrt(x * x + y * y) where x = 69.1 * (lat2 - lat1) and y = 53.0 * (lon2 - lon1) 
#$x = 69.1 * ($lat - $lats[0]);
#$y = 53.0 * ($lon - $lons[0]);
#$dist = sqrt($x * $x + $y * $y);
#$dist = sprintf("%7.2f",$dist);
#print "Cal 1: ${cos[0]} to ${co} : ${dist}\n";

#sqrt(x * x + y * y) where x = 69.1 * (lat2 - lat1) and y = 69.1 * (lon2 - lon1) * cos(lat1/57.3) 
$x = 69.1 * ($lat - $lat[$k]);
$y = 69.1 * ($lon - $lon[$k]) * cos($lat[$k]/57.3);
$dist = sqrt($x * $x + $y * $y);
$dist = sprintf("%3.0f",$dist);
$dists{$co} = $dist;
#$dists[$i] = $dist;
#print "$st to $co  : $dist\n";
#print "Cal 2: ${cons[0]} to ${co} : ${dist}\n";

#3963.0 * arccos[sin(lat1/57.2958) * sin(lat2/57.2958) + cos(lat1/57.2958) * cos(lat2/57.2958) *  cos(lon2/57.2958 -lon1/57.2958)]
#
#$x = sin($lats[0]/57.2958) * sin($lat/57.2958);
#$y = cos($lats[0]/57.2958) * cos($lat/57.2958);
#$y = $y * cos(($lon -$lons[0]) / 57.2958);
#$dist = 3963.0 * acos($x + $y);
#$dist = sprintf("%7.2f",$dist);
#print "Cal 3: ${cos[0]} to ${co} : ${dist}\n\n";
	
}

sub find_neast_sites
{

$d1 = 0;
foreach $co(@sites1){
	  
    if ($d1 == 0){ 
    	  $neast = $dists{$co}; 
    	  $nco = $co; 
    	  $d1 = 1; }
    elsif ($neast > $dists{$co}){ 
    	     $neast = $dists{$co}; 
    	     $nco = $co; 
    }	  
 
}	

}

	
#Remov leading or ending whitespace of a string
#$string = trim($string);
#@many   = trim(@many);
sub trim {
    @out = @_;
    for (@out) {
        s/^\s+//;
        s/\s+$//;
    }
    return wantarray ? @out : $out[0];
}
