#!/usr/bin/perl -w
#  this script set date period and run kymesonet_daily_db_date.pl to check/update/insert kymesonet daily data 
#  check kymesonet daily data using  kymesonet_daily_db_date.pl date  or kymesonet_daily_db_date.pl date site
#  kymesonet_daily_db_date.pl date  for check all sites
#  To check all sites:./check_dydata_date.pl start_date end_date
#  To check  one site:./check_dydata_date.pl start_date end_date SITE
#  WH Wang,20101012
$sdir = "/data/ldm/data/kymesonet/scripts";

if ($ARGV[0] && $ARGV[1]){ 
	  $sdate = $ARGV[0]; chomp($sdate);
	  $edate = $ARGV[1]; chomp($edate);
	 }
else { print "Missing input, please run:\n";
	     print "To check all sites:./check_dydata_date.pl start_date end_date\n";    
	     print "To check  one site:./check_dydata_date.pl start_date end_date SITE\n";     
	     print "For example: start_date:20101001,  end_date:20101020, SITE:CMBA\n\n";
	     #print "./check_dydata_date.pl 20080101 20080131\n";
	     #print " .OR. \n";
	     #print "./check_dydata_date.pl 20080101 20080131 CMBA\n";
	     exit;
}

if ($ARGV[2]) { 
	  $site = $ARGV[2]; 
	  chomp($site);     
}

# Julian date for Starting date
$year = substr($sdate,0,4);
$month = substr($sdate,4,2);
$day = substr($sdate,6,2);
#print "$year$month$day\n";
$jdates = date_to_julian($year, $month, $day);

# Julian date for End date
$year = substr($edate,0,4);
$month = substr($edate,4,2);
$day = substr($edate,6,2);
#print "$year$month$day\n";
$jdaten = date_to_julian($year, $month, $day);

print "start day: $sdate, Julian date:$jdates\n";
print "end day: $edate, Julian date:$jdaten\n\n";

# define run script
$script = "$sdir/kymesonet_daily_db_date.pl";

for ($dd=$jdates;$dd<=$jdaten;$dd++){

          
    # Convert Julian day to date
    $jdate = $dd;
    @ddate1 = julian_to_date($jdate);
    if ($ddate1[1]<10) {$ddate1[1] = "0" . $ddate1[1]};
    if ($ddate1[2]<10) {$ddate1[2] = "0" . $ddate1[2]};
    $date1 = $ddate1[0] . $ddate1[1] . $ddate1[2];
    print "The current day is: $date1\n";
    #print "The current day is: $date1, Julian date: $jdate \n";
    
    # run script
    if ($ARGV[2]) {
        system("$script $date1 $site");
    }else{ system("$script $date1"); }
    
    sleep 10

} # end for loop

##

	
sub IsLeapYear
{
   my $year = shift;
   return 0 if $year % 4;
   return 1 if $year % 100;
   return 0 if $year % 400;
   return 1;
}


# Convert from Date to Julian Date
# input: year, month, day     output: julian_date
# Using: $jdate=date_to_julian($year, $month, $day)

sub date_to_julian {
use integer;

return $day - 32075
+ 1461 * ( $year + 4800 - ( 14 - $month ) / 12 ) / 4
+ 367 * ( $month - 2 + ( ( 14 - $month ) / 12 ) * 12 ) / 12
- 3 * ( ( $year + 4900 - ( 14 - $month ) / 12 ) / 100 ) / 4;
}



# Convert julian day to year, month and day
# input: julian_date       output: year, month, day
#

sub julian_to_date {
use integer;

$jdate_tmp = $jdate - 1721119;
$yy1 = (4 * $jdate_tmp - 1) / 146097;
$jdate_tmp = 4 * $jdate_tmp - 1 - 146097 * $yy1;
$dd1 = $jdate_tmp/4;
$jdate_tmp = (4 * $dd1 + 3)/1461;
$dd1 = 4 * $dd1 + 3 - 1461 * $jdate_tmp;
$dd1 = ($dd1 + 4)/4;
$mm1 = (5 * $dd1 - 3) / 153;
$dd1 = 5 * $dd1 - 3 - 153 * $mm1;
$dd1 = ($dd1 + 5) / 5;
$yy1 = 100 * $yy1 + $jdate_tmp;
if ($mm1 < 10) {
$mm1 += 3;
} else {
$mm1 -= 9;
++$yy1;
}

return ($yy1, $mm1, $dd1);
}

#
