#!/usr/bin/perl -w
# WH Wang Apr 2011
# Estimating hourly precip is problem for different sites, so this is just test program.
use DBI();
use DBD::mysql;

# user / password for MySQL
require "/data/ldm/scripts/sqluser.pm";
&sqluser;

$database = "kymesonet";
#########################################################
#$dsn = "DBI:mSQL:$database";
#$con = DBI->connect($dsn) ||
#    die "Unable to connect $database :$DBI::errstr ";
#########################################################    

#
## Connect to MySQL
#

$dsn = "dbi:mysql:$database:localhost:3306";
$con = DBI->connect($dsn, $user, $passwd) or die "Unable to connect: $DBI::errstr\n";

    
#@sites = qw(FARM HTFD PCWN MRHD MRRY RSVL CMBA CRMT LXGN);
#@sites = qw(FARM HTFD PCWN MRHD MRRY RSVL CMBA CRMT LXGN BMBL PGHL);
@dbdata = qw(utme ltme tair dprc relh tdpt wspd wdir wsmx srad);
#@data_form = qw(STID UTME LTME TAIR RELH TDPT WSPD WDIR SRAD DPRC);

#$ddir = "/data/ldm/data/kymesonet/hourly/";
$tdir = "/data/ldm/data/kymesonet/scripts/temp/";
$sdir = "/data/ldm/data/kymesonet/scripts";

chdir($tdir);

# Read kymesonet sites, build @sites and @timezones
&read_kym_sites;


$utc = `date --utc +%Y%m%d%H`;   chomp($utc);
$utme = $utc;
$est = `date +%Y%m%d%H`;    chomp($est);



foreach $site(@sites){
     $tbname = $site . "_H";

     # 
     &check_db_data;
     @data = @query_out;
     
     if (!@data) { 
     	   print "$site : no data for $utme\n";     	   
     	   
     	   $line = `$sdir/search_nearest_hrsite.pl $site $lats{$site} $lons{$site}`;
     	   chomp($line);
     	   #print "$line\n";
     	   ($ss1,$ss2) = split(/\,/,$line);
     	   ($nsite1,$s1) = split(/\:/,$ss1);
     	   ($nsite2,$s2) = split(/\:/,$ss2);
     	   $s1 = trim($s1);
     	   $s2 = trim($s2);
     	   print "$site: $nsite1($s1 Miles),$nsite2($s2 Miles)\n";
     	   

     	   $tbname = $nsite1 . "_H";
     	   &check_db_data;
     	   
     	   print "$co1{$nsite1}:$nsite1 @query_out\n";
     	   
     	   $ltme = $query_out[1];
     	   $tair = $query_out[2];
     	   $dprc = $query_out[3];
     	   $relh = $query_out[4];
     	   $tdpt = $query_out[5];
     	   $wspd = $query_out[6];
     	   $wdir = $query_out[7];
     	   $wsmx = $query_out[8];
     	   $srad = $query_out[9];
     	   
     	   #print "$co1{$site}:$site $utme,$ltme,$tair,$dprc,$relh,$tdpt,$wspd,$wdir,$wsmx,$srad\n";     	    
 
     	   # 
     	   &cal_prec_incr;
     	   #print "$co1{$site}:$site $utme,$ltme,$tair,$dprc,$relh,$tdpt,$wspd,$wdir,$wsmx,$srad\n"; 
     	   
     	   $tbname = $site . "_H";  
     	   $utme = $utc;
     	   $output = "$co1{$site}:$site $utme,$ltme,$tair,$dprc,$relh,$tdpt,$wspd,$wdir,$wsmx,$srad\n";
     	   print "$output\n";   	   	  
     	   print "Update for $site ...\n";
     	   
     	   &insert_db;
 	   
     	   &write_log_file;

     	
     } else { 
     	      
     	      #print "$site\n";
     	      #print "@query_out\n\n";
     	      #&update_db; 
            
	   }
	
}	


#
$con ->disconnect;

##




# Check data in the database
sub check_db_data
{

$query = "select * from $tbname where utme=$utme";
#print "$query\n";
	
$sth = $con -> prepare($query);
$sth->execute;

@query_out = $sth->fetchrow_array;
$sth->finish;
	
}	


# Insert data to msql db
sub insert_db
{
#$tbname = $stid . "_H";

$query = "insert into $tbname values \(";
$query .= sprintf("%10s,",$utme);
$query .= sprintf("%10s,",$ltme);
$query .= sprintf("%6s,",$tair);
$query .= sprintf("%6s,",$dprc);
$query .= sprintf("%4s,",$relh);
$query .= sprintf("%6s,",$tdpt);
$query .= sprintf("%6s,",$wspd);
$query .= sprintf("%4s,",$wdir);
$query .= sprintf("%6s,",$wsmx);
$query .= sprintf("%8s",$srad);

$query .= "\)";

print "$query\n";

$con->do($query);

}

# Replace -1.0 or 999 or 999.9 with following observation
sub update_db
{
# update $tbname set tair=50.9 where utme=$utme
$j = 0;    
foreach $ss(@query_out){
    	  if ($ss =~ /-1.0/||$ss =~ /999/||$ss =~ /999.9/){
    	      #print "$j:$ss\n";   	          	      
            $dd = $dbdata[$j];
            $dd1 = ${$dd};
            
            if ($dd1 != -1.0 && $dd1 != 999 && $dd1 != 999.9){ 
                  
                  $query = "update $tbname set ";
            	    $query .= "$dd=$dd1";
            	    $query .= " where utme=$utme";
            	    
            	    print "$query\n";
            	    $con->do($query);
            }

    	  }	
    	  $j++;   
}
	
}

#COUNTY        SITE TIMEZONE LATITUDE LONGITUDE  START    LOCATION
#Adair         CMBA   CST     37.14    -85.29   20080514  Columbia 3 N

sub read_kym_sites
{
$kym_sites = "/data/ldm/data/kymesonet/scripts/kymesonet_sites";

open (INFILE,"$kym_sites");

$line = <INFILE>;

while (!eof(INFILE)) {
    $line = <INFILE>;
    chomp($line);

    ($co,$site,$tz,$lat,$lon) = split(/\s+/,$line);
    #print "$co,$site,$tz,$lat,$lon\n";

    push(@sites,$site);
    $tzs{$site} = $tz;
    $lats{$site} = $lat;
    $lons{$site} = $lon;
    $co = trim($co);
    $co1{$site} = $co;
    
    #print "$co,$site,$tzs{$site},$lats{$site},$lons{$site}\n\n";

}

close(INFILE);

}


sub cal_prec_incr
{	
$utme = $utc - 1;
&check_db_data;

print "$co1{$nsite1}:$nsite1 @query_out\n";
 
$ltme1 = $query_out[1];
$tair1 = $query_out[2];
$dprc1 = $query_out[3];
$relh1 = $query_out[4];
$tdpt1 = $query_out[5];
$wspd1 = $query_out[6];
$wdir1 = $query_out[7];
$wsmx1 = $query_out[8];
$srad1 = $query_out[9];

$tair3 = $tair - $tair1;
$dprc3 = $dprc - $dprc1;
$relh3 = $relh - $relh1;
$tdpt3 = $tdpt - $tdpt1;
$wspd3 = $wspd - $wspd1;
$wdir3 = $wdir - $wdir1;
$wsmx3 = $wsmx - $wsmx1;
$srad3 = $srad - $srad1;

#$pincr = $dprc1 - $dprc;
#if ($pincr < 0){ $pincr = 0; }

$tbname = $site . "_H";
&check_db_data;

print "$co1{$site}:$site @query_out\n";

$ltme2 = $query_out[1]; 
$tair2 = $query_out[2]; 
$dprc2 = $query_out[3]; 
$relh2 = $query_out[4]; 
$tdpt2 = $query_out[5];
$wspd2 = $query_out[6]; 
$wdir2 = $query_out[7]; 
$wsmx2 = $query_out[8]; 
$srad2 = $query_out[9]; 

$tair = $tair2 + $tair3; 
$dprc = $dprc2 + $dprc3; 
$relh = $relh2 + $relh3; 
$tdpt = $tdpt2 + $tdpt3; 
$wspd = $wspd2 + $wspd3; 
$wdir = $wdir2 + $wdir3; 
$wsmx = $wsmx2 + $wsmx3; 
$srad = $srad2 + $srad3; 

$tair = sprintf("%.1f",$tair);
$dprc = sprintf("%.2f",$dprc);
$tdpt = sprintf("%.1f",$tdpt);

if ($wspd < 0){ $wspd = "0.0"; }
else { $wspd = sprintf("%.1f",$wspd); }

if ($wdir < 0){ $wdir = 0; }

if ($wsmx < 0){ $wsmx = "0.0"; }
else { $wsmx = sprintf("%.1f",$wsmx); }

if ($srad < 0){ $srad = abs($srad); }
$srad = sprintf("%.1f",$srad);


$ltme = $ltme2 + 1;

#$dprc = $dprc2 + $pincr;     	
#print "$co1{$site}:$site @query_out\n"; 
#print "$dprc\n";  

	
}	


sub write_log_file
{

$outfile = $sdir . "/" . "update_hr.log";

print "$outfile\n";

open (OUTFILE,"+>$outfile");

print OUTFILE $output;

close(OUTFILE);

print "$output\n";


}     




#Remov leading or ending whitespace of a string
#$string = trim($string);
#@many   = trim(@many);
sub trim {
    @out = @_;
    for (@out) {
        s/^\s+//;
        s/\s+$//;
    }
    return wantarray ? @out : $out[0];
}
