#!/usr/bin/perl -w
use LWP::Simple;
use XML::Simple;
use Data::Dumper;
use DBI();
use DBD::mysql;

$xml = new XML::Simple;

# user / password for MySQL
require "/data/ldm/scripts/sqluser.pm";
&sqluser;

$database = "kymesonet";
#########################################################
#$dsn = "DBI:mSQL:$database";
#$con = DBI->connect($dsn) ||
#    die "Unable to connect $database :$DBI::errstr ";
#########################################################    

#
## Connect to MySQL
#

$dsn = "dbi:mysql:$database:localhost:3306";
$con = DBI->connect($dsn, $user, $passwd) or die "Unable to connect: $DBI::errstr\n";
    
#@sites = qw(FARM HTFD PCWN MRHD MRRY RSVL CMBA CRMT LXGN BMBL PGHL);
# Read kymesonet sites, build @sites and @timezones
&read_kym_sites;

#
chomp($dd = `/bin/date +%Y%m%d --date='1 days ago'`);
if (!$dd){ exit; }

$sutme = $dd . "00";
$eutme = $dd . "23";

foreach $stid(@sites){

        $tbname = $stid . "_H";

        &read_db_data;
        &modify_data;

}

#
$con ->disconnect;

##

# Check data in the database
sub read_db_data
{

$query = "select utme from $tbname where utme>=$sutme and utme<=$eutme order by utme";
$sth = $con -> prepare($query);
$sth->execute;

while ( $row = $sth->fetchrow_array ) {
        #print "$row\n";
        push(@utmes,$row);
}

#@query_out = $sth->fetchrow_array;
$sth->finish;
	
}	

#
sub modify_data
{
	
#
#print "@utmes\n\n";
$string = "@utmes";
print "Check missing data, download and insert to database:\n";

for ($hr=0;$hr<24;$hr++){
     if ($hr < 10){ $ddate = $dd . "0$hr"; }
     else { $ddate = $dd . $hr; }
     
     if ($string !~ /$ddate/){ 
     	   #print "$ddate\n"; 
     	   print "$ddate...";
     	   $command =  "/data/ldm/data/kymesonet/scripts/kymesonet_date.pl " . "$ddate" . "0500";
     	   #print "$command\n";
     	   system("$command");
     	   print "...done.\n";
     	   sleep 6;
     }
     #print "$ddate\n";
}
	
}

#
sub read_kym_sites
{
$kym_sites = "/data/ldm/data/kymesonet/scripts/kymesonet_sites";

open (INFILE,"$kym_sites");

$line = <INFILE>;

while (!eof(INFILE)) {
    $line = <INFILE>;
    chomp($line);

    ($co,$site,$tm) = split(/\s+/,$line);
    #print "$co,$site,$tm\n";

    push(@sites,$site);
    $timezones{$site} = $tm;

    #print "$site,$timezones{$site}\n\n";

}

close(INFILE);

}
