#!/usr/bin/perl -w
# to update missing daily data for kymesonet
# check kymesonet daily data using  kymesonet_daily_db_date.pl date  or kymesonet_daily_db_date.pl date site
# kymesonet_daily_db_date.pl date  for check all sites
# using check_dydata_date.pl start_date end_date or check_dydata_date.pl start_date end_date SITE for date period
# WH Wang,20101012
# 
use LWP::Simple;
use XML::Simple;
use Data::Dumper;
use DBI();
use DBD::mysql;
#use Scalar::Util qw(looks_like_number);

require "/data/ldm/scripts/sqluser.pm";
&sqluser;

$xml = new XML::Simple;

$database = "kymesonet";
$tbname = "kymn_dl";

#20080309 - 20081102
$dt_time = "yes";

#
## Connect to MySQL
#
$dsn = "dbi:mysql:$database:localhost:3306";
$con = DBI->connect($dsn, $user, $passwd) or die "Unable to connect: $DBI::errstr\n";

    
#@sites = qw(FARM HTFD PCWN MRHD MRRY RSVL CMBA CRMT LXGN SCTV PRNC BLRK BMBL PGHL);

#%timezones = ("FARM"->"CST","HTFD"->"CST","PCWN"->"EST","MRHD"->"EST","MRRY"->"CST","RSVL"->"CST");
#%timezones = ("FARM","CST","HTFD","CST","PCWN","EST","MRHD","EST","MRRY","CST","RSVL","CST","CMBA","CST","CRMT","EST","LXGN","EST",
#              "SCTV","CST","PRNC","CST","BLRK","CST","BMBL","EST","PGHL","CST");

#http://partners.kymesonet.org/xmldata/v1.1/rangesummary_xml.php?network=KYMN&site=all&starttime=20080414000000&stoptime=20080414235959
$http = "http://partners.kymesonet.org/xmldata/v1.3/rangesummary_xml.php?network=KYMN&site=";
#$url = "http://partners.kymesonet.org/xmldata/v1.1/rangesummary_xml.php?site=";
#
if ($ARGV[0]) { $date = $ARGV[0]; chomp($date); }
else { print "Misiing input, please run:./kymesonet_date.pl date or ./kymesonet_date.pl date SITE\n"; 
	     print "./kymesonet_date.pl 20080101\n";
	     print " .OR. \n";
	     print "./kymesonet_date.pl 20080101 CMBA\n";
	     exit;
}

if ($ARGV[1]) { 
	  $sitein = $ARGV[1]; 
	  chomp($sitein);     
}

# Read kymesonet sites, build @sites and @timezones
&read_kym_sites;

#$date = `date --date='yesterday' +%Y%m%d`;
#$date1 = `date +%Y%m%d`;
#chomp($date); chomp($date1);

# Estimate the day after
$year = substr($date,0,4);
$month = substr($date,4,2);
$day = substr($date,6,2);
print "$year$month$day\n";

# Julian date for Starting date
$jdate1 = date_to_julian($year, $month, $day);
$jdate2 = $jdate1 + 1;	
      
# Convert Julian day to date
$jdate = $jdate2;
@ddate1 = julian_to_date($jdate);
if ($ddate1[1]<10) {$ddate1[1] = "0" . $ddate1[1]};
if ($ddate1[2]<10) {$ddate1[2] = "0" . $ddate1[2]};
$date1 = $ddate1[0] . $ddate1[1] . $ddate1[2];
#print "The date for Julian date($jdate) is: $date1\n";	
print "The day after is: $date1\n";

$update = 0;
foreach $site(@sites){
	  
	  # check data start date
    $sdate = $starts{$site};
    if ($date < $sdate){ print " No data available before $sdate for $counties{$site} Co.,$site\n"; next; }
	  
	  # Insert to db "kymesonet" 
    &check_db_data;
     if (!@query_out) { $update = 1; }
     else{
     #	  $site = $query_out[0];
         $ddate = $query_out[1];
      	 $tmx = $query_out[2];  #$tmx = sprintf("%3d", $tmx);
     	   $tmn = $query_out[3];  #$rh_mn = sprintf("%3d",$rh_mn);
         $prc = $query_out[4]; 
         $hmx = $query_out[5];  #$rh_mx = sprintf("%3d",$rh_mx);
         $hmn = $query_out[6]; #$rh_mn = sprintf("%3d",$rh_mn);
         $atd = $query_out[7];
         $wsa = $query_out[8];
         $wsx = $query_out[9];
         #print "$site, $ddate, $tmx, $tmn, $prc, $hmx, $hmn, $atd, $wsa, $wsx\n"; 
         
         if ($tmx>998||$tmn>998||$hmx>998||$hmn>998||$atd>998||$wsa>999||$wsx>999||$prc<0){ $update = 2;  
         print "$site, $ddate, $tmx, $tmn, $prc, $hmx, $hmn, $atd, $wsa, $wsx\n";
        } else { $update = 0; }
         
    }
    
    # Insert/update data to db
    if ($update == 1||$update == 2){ 
       &download_data;
    	 if ($update == 1){ 
    	 	   print "insert data to $site...\n"; 
    	     &insert_db;
    	 } else { 
    	 	       print "update date to $site...\n"; 
    	 	       &update_db; 
    	 }   	  

    }
             
    #last;   	
}

#
$con ->disconnect;

##
sub download_data
{	
$timezone = $timezones{$site};
# Change ST to DT
if ($dt_time eq "yes"||$dt_time eq "y"){ &timezone_st2dt; }

# Calculate UTMC
&ltme_to_utmc;
$starttime = $date . $utc_hh . "0000";
$stoptime = $date1 . $utc_hh1 . "5959";

$url = $http . $site . "&" ."starttime=$starttime" . "&" . "stoptime=$stoptime"; 
print "$url\n";

$xdata = get("$url");
#print "$xdata\n\n";
$data = $xml->parse_string($xdata);
&print_data;
&parse_data;	
                          
}	

sub timezone_st2dt
{
# Change time zone if wrong selection out of Daylight Time(in Summer)
#if ($timezone eq "EDT"){ $timezone = "EST"; }
#elsif ($timezone eq "CDT"){ $timezone = "CST"; }
#elsif ($timezone eq "MDT"){ $timezone = "MST"; }
#elsif ($timezone eq "PDT"){ $timezone = "PST"; }   

if ($timezone eq "EST" || $timezone eq "Eastern"){ $timezone = "EDT"; }
elsif ($timezone eq "CST" || $timezone eq "Central"){ $timezone = "CDT"; }
elsif ($timezone eq "MST" || $timezone eq "Mountain"){ $timezone = "MDT"; }
elsif ($timezone eq "PST" || $timezone eq "Pacific"){ $timezone = "PDT"; }   

}

# Converting LTME to UTME
sub ltme_to_utmc
{    
# UTC Time
if ($timezone eq "EST"){ $utc_hh = 5; }        # EST Time = UTC -5 hrs                           
elsif ($timezone eq "EDT"){ $utc_hh = 4; }   	 # EDT Time = UTC -4 hrs               
elsif ($timezone eq "CST"){ $utc_hh = 6; }     # CST Time = UTC -6 hrs                
elsif ($timezone eq "CDT"){ $utc_hh = 5; }     # CDT Time = UTC -5 hrs                
elsif ($timezone eq "MST"){ $utc_hh = 7; }     # MST Time = UTC -7 hrs           	
elsif ($timezone eq "MDT"){ $utc_hh = 6; }     # MDT Time = UTC -6 hrs                      	
elsif ($timezone eq "PST"){ $utc_hh = 8; }     # PST Time = UTC -8 hrs        
elsif ($timezone eq "PDT"){ $utc_hh = 7; }     # PDT Time = UTC -7 hrs                                  	      

#if ($utc_hh < 10){ $utc_hh = "0" . $utc_hh; } 
$utc_hh1 = $utc_hh - 1;
$utc_hh = "0" . $utc_hh;	 
$utc_hh1 = "0" . $utc_hh1;
}

# Parsing and bulding msql string
sub parse_data
{
# read XML file
#&print_data;

$stid = $data->{RangeSummary}->{STID};
if (!$stid){ return; }

#XTMX Maximum 1.5m temperature C
# XTMX:23.7 C to F
$xtmx = $data->{RangeSummary}->{XTMX}->{content};
if (!$xtmx || $xtmx =~ m/^[a-zA-Z]+$/){ $xtmx = 999.9; }
else { $xtmx = 32 + 1.8 * $xtmx;  }
$xtmx = sprintf("%5.1f",$xtmx);

#XTMN Minimum 1.5m temperature C
# XTMN:6 C to F
$xtmn = $data->{RangeSummary}->{XTMN}->{content};
if (!$xtmn || $xtmn =~ m/^[a-zA-Z]+$/){ $xtmn = 999.9; }
else { $xtmn = 32 + 1.8 * $xtmn;  }
$xtmn = sprintf("%5.1f",$xtmn);

#XPRC Total precipitation mm
# converting mm to inch
$xprc = $data->{RangeSummary}->{XPRC}->{content};
if ($xprc eq "" || $xprc =~ m/^[a-zA-Z]+$/){ $xprc = -1.0; }
else { $xprc = 0.03937 * $xprc; }
$xprc = sprintf("%4.2f",$xprc);

#XHMX Maximum relative humidity % 1.5m
$xhmx = $data->{RangeSummary}->{XHMX}->{content};
if (!$xhmx || $xhmx =~ m/^[a-zA-Z]+$/){ $xhmx  = 999; }
$xhmx = sprintf("%5.0f",$xhmx);

#XHMN Minimum relative humidity % 1.5m
$xhmn = $data->{RangeSummary}->{XHMN}->{content};
if (!$xhmn || $xhmn =~ m/^[a-zA-Z]+$/){ $xhmn  = 999; }
$xhmn = sprintf("%5.0f",$xhmn);

#XATD Average dewpoint temperature C 1.5m
# XATD:6.1 C to F
$xatd = $data->{RangeSummary}->{XATD}->{content};
if (!$xatd || $xatd =~ m/^[a-zA-Z]+$/){ $xatd = 999.9; }
else { $xatd = 32 + 1.8 * $xatd;  }
$xatd = sprintf("%5.1f",$xatd);

#XWSA Average wind speed ms-1 10m
# converting meter/s to mile/h
$xwsa = $data->{RangeSummary}->{XWSA}->{content};
if (!$xwsa || $xwsa =~ m/^[a-zA-Z]+$/){ $xwsa = 999.9; }
else { $xwsa = 2.23694 * $xwsa; }
$xwsa = sprintf("%5.1f",$xwsa); 

#XWSX Maximum wind gust ms-1 10m
#converting meter/s to mile/h
$xwsx = $data->{RangeSummary}->{XWSX}->{content};
if (!$xwsx || $xwsx =~ m/^[a-zA-Z]+$/){ $xwsx = 999.9; }
else { $xwsx = 2.23694 * $xwsx; }
$xwsx = sprintf("%5.1f",$xwsx); 

#print "$stid,$date,$xtmx,$xtmn,$xprc,$xhmx,$xhmn,$xatd,$xwsa,$xwsx\n";

# Insert/update data to db "kymesonet" 
#if ($update == 1){ &insert_db; }
#else{ &update_db;  }
	
}

# Check data in the database
sub check_db_data
{
	
$query = "select * from $tbname where stid='$site' and ltme=$date";
$sth = $con -> prepare($query);
$sth->execute;

@query_out = $sth->fetchrow_array;
$sth->finish;
	
}	


# Update db with data
sub update_db
{

$query = "update $tbname set ";
$query .= "xtmx=$xtmx, ";
$query .= "xtmn=$xtmn, ";
$query .= "xprc=$xprc, ";
$query .= "xhmx=$xhmx, ";
$query .= "xhmn=$xhmn, ";
$query .= "xatd=$xatd, ";
$query .= "xwsa=$xwsa, ";
$query .= "xwsx=$xwsx ";

$query .= "where stid='$stid' and ltme=$date";
#$query="update kymn_dl set xtmx= 82.8, xtmn= 46.2, xprc=0.00, xhmx=   97, xhmn=   28, xatd= 47.7, xwsa=  5.4, xwsx= 24.4 where stid='CRMT' and ltme=20100930";

print "$query\n\n";

$cursor = $con->do($query);

print "...updated.\n\n";

}


# Insert data to msql db
sub insert_db
{
$ch =  "'$stid'";
$query = "insert into $tbname values\(";
$query .= sprintf("%4s,",$ch);
$query .= sprintf("%10s,",$date);
$query .= sprintf("%6s,",$xtmx);
$query .= sprintf("%6s,",$xtmn);
$query .= sprintf("%6s,",$xprc);
$query .= sprintf("%4s,",$xhmx);
$query .= sprintf("%4s,",$xhmn);
$query .= sprintf("%6s,",$xatd);
$query .= sprintf("%6s,",$xwsa);
$query .= sprintf("%6s",$xwsx);

$query .= "\)";

print "$query\n\n";

$cursor = $con->do($query);

}


sub print_data
{

# print output
#print "dump data:\n";
#print Dumper($data);
print "\n:";
# access XML data

print "STID:$data->{RangeSummary}->{STID}\n";
print "XTMX:$data->{RangeSummary}->{XTMX}->{content}\n";
print "XTMN:$data->{RangeSummary}->{XTMN}->{content}\n";
print "XHMX:$data->{RangeSummary}->{XHMX}->{content}\n";
print "XHMN:$data->{RangeSummary}->{XHMN}->{content}\n";
print "XATD:$data->{RangeSummary}->{XATD}->{content}\n";
print "XPRC:$data->{RangeSummary}->{XPRC}->{content}\n";
print "XWSA:$data->{RangeSummary}->{XWSA}->{content}\n";
print "XWSX:$data->{RangeSummary}->{XWSX}->{content}\n";

#print "\n";
	

}
	
sub IsLeapYear
{
my $year = shift;
return 0 if $year % 4;
return 1 if $year % 100;
return 0 if $year % 400;
return 1;
}


# Convert from Date to Julian Date
# input: year, month, day     output: julian_date
# Using: $jdate=date_to_julian($year, $month, $day)

sub date_to_julian {
use integer;

return $day - 32075
+ 1461 * ( $year + 4800 - ( 14 - $month ) / 12 ) / 4
+ 367 * ( $month - 2 + ( ( 14 - $month ) / 12 ) * 12 ) / 12
- 3 * ( ( $year + 4900 - ( 14 - $month ) / 12 ) / 100 ) / 4;
}



# Convert julian day to year, month and day
# input: julian_date       output: year, month, day
#

sub julian_to_date {
use integer;

$jdate_tmp = $jdate - 1721119;
$yy1 = (4 * $jdate_tmp - 1) / 146097;
$jdate_tmp = 4 * $jdate_tmp - 1 - 146097 * $yy1;
$dd1 = $jdate_tmp/4;
$jdate_tmp = (4 * $dd1 + 3)/1461;
$dd1 = 4 * $dd1 + 3 - 1461 * $jdate_tmp;
$dd1 = ($dd1 + 4)/4;
$mm1 = (5 * $dd1 - 3) / 153;
$dd1 = 5 * $dd1 - 3 - 153 * $mm1;
$dd1 = ($dd1 + 5) / 5;
$yy1 = 100 * $yy1 + $jdate_tmp;
if ($mm1 < 10) {
$mm1 += 3;
} else {
$mm1 -= 9;
++$yy1;
}

return ($yy1, $mm1, $dd1);
}

#
sub read_kym_sites
{
$kym_sites = "/data/ldm/data/kymesonet/scripts/kymesonet_sites";

open (INFILE,"$kym_sites");

$line = <INFILE>;

while (!eof(INFILE)) {
    $line = <INFILE>;
    chomp($line);

    #($co,$site,$tm) = split(/\s+/,$line);
    ($co,$site,$tm,$lat,$lon,$start,$loc) = split(/\s+/,$line);
    #print "$co,$site,$tm\n";

    if ($ARGV[1] && $sitein eq $site) { @sites = "$site"; }    
    else { push(@sites,$site); }

    $timezones{$site} = $tm;
    $counties{$site} = $co;
    #$lats{$site} = $lat;
    #$lons{$site} = $lon;
    $starts{$site} = $start;
    #$locs{$site} = $loc;    
  
    #print "$site,$timezones{$site}\n\n";
    if ($ARGV[1] && $sitein eq $site) { last; }
    

}

close(INFILE);

}
