#!/usr/bin/perl -w
use LWP::Simple;
use XML::Simple;
use Data::Dumper;
use DBI();
use DBD::mysql;

require "/data/ldm/scripts/sqluser.pm";
&sqluser;

$xml = new XML::Simple;

$database = "kymesonet";

#
## Connect to MySQL
#
$dsn = "dbi:mysql:$database:localhost:3306";
$con = DBI->connect($dsn, $user, $passwd) or die "Unable to connect: $DBI::errstr\n";
    
@sites = qw(FARM HTFD PCWN MRHD MRRY RSVL);
@dbdata = qw(utme ltme tair dprc relh tdpt wspd wdir wsmx srad);
#@data_form = qw(STID UTME LTME TAIR RELH TDPT WSPD WDIR SRAD DPRC);
#$url = "http://www.kymesonet.org/site_latest_data_xml.php?site=";
$url = "http://partners.kymesonet.org/xmldata/v1.3/site_latest_data_xml.php?site=";
#$site_xml = "site_latest_data_xml.php?site=";

#$ddir = "/data/ldm/data/kymesonet/hourly/";
$tdir = "/data/ldm/data/kymesonet/scripts/temp/";
#$sdir = "/data/ldm/data/kymesonet/scripts/";

chdir($tdir);

# download each site
#&download_each;

# download all site
&download_all;

#
$con ->disconnect;

##

# download each site
sub download_each
{

foreach $site(@sites)
{
  #if ($site eq "FARM"){
   	$doc = get("$url$site");
   	print "doc:\n";
   	print "$doc\n\n";
   	#system("wget $url$site");	
   	#system("mv $site_xml$site $site");
	  &parse_data1;
	#}
}

}	

# download all sites
sub download_all
{
$xml_head = "<?xml version=\"1.0\"?>";
$obsgroup = "</ObservationGroup>";
$obsb = "<Observations>";
$obse = "</Observations>";

$url = $url . "ALL";
$obs = get("$url");
#print "obs:\n";
#print "$obs:\n\n";

@docs = split(/\n/,$obs);

print "docs:\n";
#print "@docs\n\n";


$obs = "";

foreach $str(@docs){
	   print "$str\n";
     $obs .= $str . "\n";
     if ($str =~ /$obsgroup/){
     	   $obs .= $obse . "\n";
     	   #print "$obs\n\n";
     	   &parse_data;
     	   
     	   $obs = $xml_head . "\n";
     	   $obs .= $obsb . "\n";
     	   
     }	
	
}	

}

# Parsing and bulding msql string
sub parse_data
{
# read XML file

#$data = $xml;
$data = $xml->parse_string($obs);

# print output
#print "dump data:\n";
#print Dumper($data);
#print "\n:";
# access XML data
print "\n:";
print "STID:$data->{ObservationGroup}->{STID}\n";
print "LTME:$data->{ObservationGroup}->{LTME}->{content}\n";
print "TAIR:$data->{ObservationGroup}->{TAIR}->{content}\n";
print "DPRC:$data->{ObservationGroup}->{DPRC}->{content}\n";
print "RELH:$data->{ObservationGroup}->{RELH}->{content}\n";
print "TDPT:$data->{ObservationGroup}->{TDPT}->{content}\n";
print "WSPD:$data->{ObservationGroup}->{WSPD}->{content}\n";
print "WDIR:$data->{ObservationGroup}->{WDIR}->{content}\n";
print "WSMX:$data->{ObservationGroup}->{WSMX}->{content}\n";
print "SRAD:$data->{ObservationGroup}->{SRAD}->{content}\n";

print "\n";

$stid = $data->{ObservationGroup}->{STID};
if (!$stid){ return; }
# UTME:2008-02-15 10:10:00
$utme = $data->{ObservationGroup}->{UTME}->{content};
if (!$utme){ return; }
@str = $utme =~ /(\d+)/g; 
$utme = "$str[0]$str[1]$str[2]$str[3]";

# LTME:2008-02-15 10:10:00
$ltme = $data->{ObservationGroup}->{LTME}->{content};
if (!$utme){ return; }
@str = $ltme =~ /(\d+)/g; 
$hour = $str[3];
$ltme = "$str[0]$str[1]$str[2]$str[3]";

#($s1,$s2) = split(/\s+/,$ltme);
# TAIR:9.14 C to F
$tair = $data->{ObservationGroup}->{TAIR}->{content};
if (!$tair){ $tair = 999.9; }
else { $tair = 32 + 1.8 * $tair;  }
$tair = sprintf("%5.1f",$tair);

# converting mm to inch
$dprc = $data->{ObservationGroup}->{DPRC}->{content};
#if (!$dprc){ $dprc = -1.0; }
#if (!$dprc){ $dprc = 0.00; }
if ($dprc eq ""){ $dprc = -1.0; }
else { $dprc = 0.03937 * $dprc; }
$dprc = sprintf("%4.2f",$dprc);

$relh = $data->{ObservationGroup}->{RELH}->{content};
if (!$relh){ $relh  = 999; }
$relh = sprintf("%5.0f",$relh);

# converting mm to inch
$tdpt = $data->{ObservationGroup}->{TDPT}->{content};
if (!$tdpt){ $tdpt = 999.9; }
else { $tdpt = 32 + 1.8 * $tdpt; }
$tdpt = sprintf("%5.1f",$tdpt);

# converting meter/s to mile/h
$wspd = $data->{ObservationGroup}->{WSPD}->{content};
if (!$wspd){ $wspd = 999.9; }
else { $wspd = 2.23694 * $wspd; }
$wspd = sprintf("%5.1f",$wspd); 

$wdir = $data->{ObservationGroup}->{WDIR}->{content};
#if ($wdir eq ""){ $wdir = 999; }
if (!$wdir){ $wdir = 999; }
$wdir = sprintf("%5.0f",$wdir);

#converting meter/s to mile/h
$wsmx = $data->{ObservationGroup}->{WSMX}->{content};
if (!$wsmx){ $wsmx = 999.9; }
else { $wsmx = 2.23694 * $wsmx; }
$wsmx = sprintf("%5.1f",$wsmx); 

$srad = $data->{ObservationGroup}->{SRAD}->{content};
if (!$srad){ 
	  if ($hour <= 6 || $hour >= 18){ $srad = 0.0; } 
	  else { $srad = -1.0; }	  
}
$srad = sprintf("%6.1f",$srad);
#print "$stid,$ltme,$tair,$dprc,$relh,$tdpt,$wspd,$wdir,$wsmx,$srad\n";

# Insert to db "kymesonet" 
$tbname = $stid . "_H";
#&check_db_data;
#if (!@query_out) { &insert_db; }
#else { &update_db; }

&insert_db;

}

# Check data in the database
sub check_db_data
{
	
$query = "select * from $tbname where utme=$utme";
$sth = $con -> prepare($query);
$sth->execute;

@query_out = $sth->fetchrow_array;
$sth->finish;
	
}	


# Insert data to msql db
sub insert_db
{
#$tbname = $stid . "_H";

$query = "insert into $tbname values \(";
$query .= sprintf("%10s,",$utme);
$query .= sprintf("%10s,",$ltme);
$query .= sprintf("%6s,",$tair);
$query .= sprintf("%6s,",$dprc);
$query .= sprintf("%4s,",$relh);
$query .= sprintf("%6s,",$tdpt);
$query .= sprintf("%6s,",$wspd);
$query .= sprintf("%4s,",$wdir);
$query .= sprintf("%6s,",$wsmx);
$query .= sprintf("%8s",$srad);

$query .= "\)";

print "$query\n";

#$con->do($query);

}

# Replace -1.0 or 999 or 999.9 with following observation
sub update_db
{
# update $tbname set tair=50.9 where utme=$utme
$j = 0;    
foreach $ss(@query_out){
    	  if ($ss =~ /-1.0/||$ss =~ /999/||$ss =~ /999.9/){
    	      #print "$j:$ss\n";   	          	      
            $dd = $dbdata[$j];
            $dd1 = ${$dd};
            
            if ($dd1 != -1.0 && $dd1 != 999 && $dd1 != 999.9){ 
                  
                  $query = "update $tbname set ";
            	    $query .= "$dd=$dd1";
            	    $query .= " where utme=$utme";
            	    
            	    print "$query\n";
            	    #$con->do($query);
            }

    	  }	
    	  $j++;   
}
	
}
