#!/usr/bin/perl -w
#  this script read kymesonet daily data from kymesonet database 
#DB:wxdb,TABLE kymsites(station CHAR(22),ddate INT,tmax INT,tmin INT,precip REAL,type CHAR(1),aeflag CHAR(1))
#please run: ./check_estimate_kymsites.pl 20101101 for check and estimate data of 20101101
# or ./check_estimate_kymsites.pl for check and estimate data of yesterday
#  WH Wang,20101215
use Math::Trig;
use DBI();

$database = "kymesonet";
$tbname = "kymn_dl";
$dsn = "DBI:mSQL:$database";

$sdir = "/data/ldm/data/kymesonet/scripts/";
#$ddir = "/data/ldm/data/kymesonet/PM";
$logfile = $sdir . "check_estimate.log";

$yesterday = `date --date='yesterday' +%Y%m%d`;
chomp($yesterday);

# data dir
$kymsites = "kymesonet_sites";

if ($ARGV[0]){ $input = $ARGV[0]; chomp($input); }
else { print "run: ./check_estimate_kymsites.pl or ./check_estimate_kymsites.pl date\n";   
	     print "For example:./check_estimate_kymsites.pl 20101201  -- for check and estimate data of 20101101\n";	
	     print "or ./check_estimate_kymsites.pl for check and estimate data of yesterday\n\n";	       
	     #exit;
}

$con = DBI->connect($dsn) ||
    die "Unable to connect $database $tbname:$DBI::errstr ";

#if ($input =~ /\d+/){  }
if ($ARGV[0]){ $ddate = $input; }
else { $ddate = $yesterday; }

#	
&read_kymsites;	

#$where = "ddate=" . $ddate;
#$where = "ddate=$ddate";
&read_db_data;

#
&estimate_neast_sites;

#
$con ->disconnect;

#

print "\n\n";
#@sorted= sort @sites;
#print "@sorted\n\n";
#foreach $ss(@sorted){ print "$ss\n"; }

##


# Check data in the database
sub read_db_data
{

#$query = "select station,tmax,tmin,precip from $tbname where ddate=$ddate order by station";
$query = "select * from $tbname where ltme=$ddate";
#$query = "select * from $tbname where ltme=$ddate order by stid";

$sth = $con -> prepare($query);
$sth->execute;

print "Read $tbname DB data ...\n";

$j = 0;
$k = 0;
while(@row = $sth->fetchrow_array) { 
    #print "@row\n";
    
    $st = $row[0];
    $ddate = $row[1];
    $tmx = $row[2];  #$tmx = sprintf("%3d", $tmx);
    $tmn = $row[3];  #$rh_mn = sprintf("%3d",$rh_mn);
    $prc = $row[4]; 
    $hmx = $row[5];  #$rh_mx = sprintf("%3d",$rh_mx);
    $hmn = $row[6]; #$rh_mn = sprintf("%3d",$rh_mn);
    $atd = $row[7];
    $wsa = $row[8];
    $wsx = $row[9];
       
    $st = trim($st);
    $data{$st} = "$tmx,$tmn,$prc,$hmx,$hmn,$atd,$wsa,$wsx";    
    $prc1 = abs($prc);
    
    if ($tmx>120||$tmn>120||$prc1>9||$hmx>100||$hmn>100||$atd>110||$wsa > 120||$wsx > 120){     	   	
    	   #$missing{$st} = "$tmx,$tmn,$prc";  
    	   $msite[$k] = $st;
    	   print "Missing data: "; 
    	   $k++;
    }else{ push(@sites,$st); }
 
    #print "$county{$st},$st,$data{$st}\n";          
    $j++;    
}

$sth->finish;

print "...total data readed from DB $tbname : $j  Missing data: $k\n\n";

}

# read kymesonet_sites file 
sub read_kymsites
{
#COUNTY        SITE TIMEZONE LATITUDE LONGITUDE  START     LOCATION
print "Read $kymsites file...\n";

$file = $sdir . $kymsites;

open (INFILE,"$file");

$i = 0;
while (!eof(INFILE)) {
    $line = <INFILE>;
    chomp($line);
    #print "$line\n";
    
    ($co,$stid,$tz,$lat,$lon,$start,$loc) = split(/\s+/,$line);
    chomp($line);
    
    $loc = trim($loc);    
    $stid = trim($stid);
    $co = trim($co);
    $tz = trim($tz);
    $lat = trim($lat);
    $lon = trim($lon);   
    
    $county{$stid} = $co;
    #$stids{$co} = $stid;
    
    if ($i > 0){
        #push(@counties,$co);
    
        $lat{$stid} = $lat;
        $lon{$stid} = $lon;
    }
    #print "$co,$stid,$lat,$lon\n";
    
    #$d1 = $data{$co};    
    #$co = sprintf("%-21s",$co);
    #print "$co,$stid,$co,$tz,$lat,$lon\n"; 
    #print "$co,$ddate,$lat,$lon,$d1\n"; 
    #&read_db_data;  	
    
    $i++;     
    
}

close(INFILE);
$i = $i - 1;
print "Total data readed from $kymsites : $i\n\n";

}

#
#Calculate distance of neast sites for estimating missing data
sub estimate_neast_sites
{
	
$k = $k-1;
while($k >= 0){
	   
	   $mst = $msite[$k];
	   $lat[$k] = $lat{$mst};
	   $lon[$k] = $lon{$mst};
	   print "Missing site: $county{$mst},$mst,$lat[$k],$lon[$k]($data{$mst})\n";
	   
	   
     foreach $loc(@sites){
        $lat = $lat{$loc};
        $lon = $lon{$loc};
        #print "Esimate site: $loc,$lat,$lon\n";
	      &cal_distance;       
	      
	   }
	  
	  #@sorted = sort @dists;
	  #print "@sorted\n";
	  
	  @sites1 = @sites;
	  $i = 0;
	  $tdist = 0;
	  while($i < 3){      
	      &find_neast_sites;  
	      $str1 = " ${nloc}($lat{$nloc},$lon{$nloc})";
	      $str1 = sprintf("%-36s",$str1);  
	      $str2 = sprintf("%3s",$neast);	
	      ($tmx1,$tmn1,$prc1) = split(/\,/,$data{$nloc});  
	      $tmx1 = sprintf("%5.0f",$tmx1);
	      $tmn1 = sprintf("%5.0f",$tmn1);
	      $prc1 = sprintf("%6.2f",$prc1);	          	      
	      #print "The distance from $mst to ${nloc}($lat{$nloc},$lon{$nloc}) : $neast\n";
	      print "The distance from $mst to $str1 : ${str2}($data{$nloc})\n";
	      
	      #$dat[$i] = $data{$nloc};
	      #print "$nloc,$dat[$i]\n";
	      #	        	      	      
	      if ($neast <= 6){ 
	      	 print "$nloc,$tmx1,$tmn1,$prc1\n";
	      	 last;      
 	      }else{ 
 	      	  $nlocs[$i] = $nloc;
 	      	  #$neasts[$i] = $neast;
 	          $tdist = $tdist + $neast;
 	      }
 	       	      
 	      @sites2 = "";
 	      $d1 = 0;
        foreach $ss(@sites1){
        	   if ($ss ne $nloc){ 
        	   	   if ($d1 == 0){ @sites2 = $ss; $d1 = 1; }
        	   	   else{ push(@sites2,$ss); }
        	   }
        }	
	      	      
	      @sites1 = @sites2;
	      
	      $i++;
	      
	  }
	  
	  &update_missing_data;
	  
	  $k--;
	  print "\n";
}	

}

#
sub cal_distance
{

#sqrt(x * x + y * y) where x = 69.1 * (lat2 - lat1) and y = 53.0 * (lon2 - lon1) 
#$x = 69.1 * ($lat - $lats[0]);
#$y = 53.0 * ($lon - $lons[0]);
#$dist = sqrt($x * $x + $y * $y);
#$dist = sprintf("%7.2f",$dist);
#print "Cal 1: ${locs[0]} to ${loc} : ${dist}\n";

#sqrt(x * x + y * y) where x = 69.1 * (lat2 - lat1) and y = 69.1 * (lon2 - lon1) * cos(lat1/57.3) 
$x = 69.1 * ($lat - $lat[$k]);
$y = 69.1 * ($lon - $lon[$k]) * cos($lat[$k]/57.3);
$dist = sqrt($x * $x + $y * $y);
$dist = sprintf("%3.0f",$dist);
$dists{$loc} = $dist;
#$dists[$i] = $dist;
#print "$mst to $loc  : $dist\n";
#print "Cal 2: ${locs[0]} to ${loc} : ${dist}\n";

#3963.0 * arccos[sin(lat1/57.2958) * sin(lat2/57.2958) + cos(lat1/57.2958) * cos(lat2/57.2958) *  cos(lon2/57.2958 -lon1/57.2958)]
#
#$x = sin($lats[0]/57.2958) * sin($lat/57.2958);
#$y = cos($lats[0]/57.2958) * cos($lat/57.2958);
#$y = $y * cos(($lon -$lons[0]) / 57.2958);
#$dist = 3963.0 * acos($x + $y);
#$dist = sprintf("%7.2f",$dist);
#print "Cal 3: ${locs[0]} to ${loc} : ${dist}\n\n";
	
}

sub find_neast_sites
{

$d1 = 0;
foreach $loc(@sites1){
	  #$locs[$j] = $loc;
    if ($d1 == 0){ 
    	  $neast = $dists{$loc}; 
    	  $nloc = $loc; 
    	  $d1 = 1; }
    elsif ($neast > $dists{$loc}){ 
    	     $neast = $dists{$loc}; 
    	     $nloc = $loc; 
    }	  
 
}	

}

#update missing data 
sub update_missing_data
{

if ($neast <= 6){ 	
	  $dat = $data{$nloc}; 
	 ($tmax,$tmin,$prec,$hmax,$hmin,$xatd,$xwsa,$xwsx) = split(/\,/,$dat);
	
}else{
     $tmax = 0;
     $tmin = 0;
     $prec = 0;
     $hmax = 0;
     $hmin = 0;
     $xatd = 0;
     $xwsa = 0;
     $xwsx = 0;
     
     $tmx1 = 3;
     $tmn1 = 3;
     $hmx1 = 3;
     $hmn1 = 3;
     $atd1 = 3;
     $wsa1 = 3;
     $wsx1 = 3;
     
     for ($j=0;$j<3;$j++){
     	   
     	   $nloc = $nlocs[$j];
     	   $dat = $data{$nloc};
     	   ($tmx,$tmn,$prc,$hmx,$hmn,$atd,$wsa,$wsx) = split(/\,/,$dat);
     	        	
         if ($prc < 0||$prc > 9){ $prc = 0; }         
         if ($tmx > 120){ $tmx = 0; $tmx1 = $tmx1 - 1; } 
         if ($tmn > 120){ $tmn = 0; $tmn1 = $tmn1 - 1; }         
         if ($hmx > 100){ $hmx = 0; $hmx1 = $hmx1 - 1; } 
         if ($hmn > 100){ $hmn = 0; $hmn1 = $hmn1 - 1; }          
         if ($atd > 110){ $atd = 0; $atd1 = $atd1 - 1; } 
         if ($wsa > 120){ $wsa = 0; $wsa1 = $wsa1 - 1; } 
         if ($wsx > 120){ $wsx = 0; $wsx1 = $wsx1 - 1; } 
         
         $tmax = $tmax + $tmx;
         $tmin = $tmin + $tmn;         
         $prec = $prec + $prc;	
         
         $hmax = $hmax + $hmx;
         $hmin = $hmin + $hmn;         
         $xatd = $xatd + $atd;
         $xwsa = $xwsa + $wsa;
         $xwsx = $xwsx + $wsx;  
         
     }
     $tmax = $tmax / $tmx1;
     $tmin = $tmin / $tmn1;
     $prec = $prec / 3;
     $hmax = $hmax / $hmx1;
     $hmin = $hmin / $hmn1;
     $xatd = $xatd / $atd1;
     $xwsa = $xwsa / $wsa1;
     $xwsx = $xwsx / $wsx1; 
}

# check available data for missing site
$dat = $data{$mst}; 
($tmx,$tmn,$prc,$hmx,$hmn,$atd,$wsa,$wsx) = split(/\,/,$dat);

if ($tmx < 120){ 
	  $d1 = $tmax - $tmx;
	  $d1 = abs($d1);
	  if ($d1 < 5){ $tmax = $tmx ; }
}	  	
if ($tmn < 120){
	  $d1 = $tmin - $tmn;
	  $d1 = abs($d1);
	  if ($d1 < 5){ $tmin = $tmn ; }
}	  		
if ($prc >= 0&&$prc < 9){ 
	  $d1 = $prec - $prc;
	  $d1 = abs($d1);
	  if ($d1 < 1){ $prec = $prc ; }	
}
if ($hmx <= 100){ 
	  $d1 = $hmax - $hmx;
	  $d1 = abs($d1);
	  if ($d1 < 10){ $hmax = $hmx ; }
}	  	
if ($hmn <= 100){ 
	  $d1 = $hmin - $hmn;
	  $d1 = abs($d1);
	  if ($d1 < 10){ $hmin = $hmn ; }
}	  	
if ($atd < 110){
	  $d1 = $xatd - $atd;
	  $d1 = abs($d1);
	  if ($d1 < 5){ $xatd = $atd ; }
}	  		
if ($wsa < 120){
	  $d1 = $xwsa - $wsa;
	  $d1 = abs($d1);
	  if ($d1 < 10){ $xwsa = $wsa ; }
}	  		
if ($wsx < 120){
	  $d1 = $xwsx - $wsx;
	  $d1 = abs($d1);
	  if ($d1 < 20){ $xwsx = $wsx ; }
}	  		

$tmax = sprintf("%5.1f",$tmax);
$tmin = sprintf("%5.1f",$tmin);
$prec = sprintf("%5.2f",$prec);

$hmax = sprintf("%4.0f",$hmax);
$hmin = sprintf("%4.0f",$hmin);
$xatd = sprintf("%5.1f",$xatd);
$xwsa = sprintf("%5.1f",$xwsa);
$xwsx = sprintf("%5.1f",$xwsx);

$query = "update $tbname set ";
$query .= "xtmx=$tmax, ";
$query .= "xtmn=$tmin, ";
$query .= "xprc=$prec, ";
$query .= "xhmx=$hmax, ";
$query .= "xhmn=$hmin, ";
$query .= "xatd=$xatd, ";
$query .= "xwsa=$xwsa, ";
$query .= "xwsx=$xwsx ";

$query .= "where stid='$mst' and ltme=$ddate";

#print "$query\n\n";

$strs = "$county{$mst},$mst,$ddate,$tmax,$tmin,$prec,$hmax,$hmin,$xatd,$xwsa,$xwsx";
print "updating for $strs\n";
 
#$cursor = $con->do($query);
$con->do($query);

print "...updated .\n\n";

&write_logfile;
	
}


sub write_logfile
{

$strs = "updated for $strs" . "\n";
	
open (INFILE,">>$logfile");
	
print INFILE $strs;

close(INFILE);

}	

#Remov leading or ending whitespace of a string
#$string = trim($string);
#@many   = trim(@many);
sub trim {
    @out = @_;
    for (@out) {
        s/^\s+//;
        s/\s+$//;
    }
    return wantarray ? @out : $out[0];
}
