#!/usr/bin/perl -w
use LWP::Simple;
use XML::Simple;
use Data::Dumper;
use DBI();

$xml = new XML::Simple;

$database = "kymesonet";
    
#@sites = qw(FARM HTFD PCWN MRHD MRRY RSVL);
#@sites = qw(FARM HTFD PCWN MRHD MRRY RSVL CMBA CRMT LXGN BMBL PGHL);
#
if ($ARGV[0]&&$ARGV[1]&&$ARGV[2]) { 
	 $stid = $ARGV[0]; chomp($stid);
	 $sdate = $ARGV[1]; chomp($sdate);
	 $edate = $ARGV[2]; chomp($edate);	
} else { print "Misiing input(site start_date end_date), please run:./check_site_date.pl site 20080101 20080102\n"; exit; }

#
print "$ARGV[0],$ARGV[1],$ARGV[2]\n";
$tbname = $stid . "_H";

# Read kymesonet sites, build @sites and @timezones
&read_kym_sites;

#
$sutme = $sdate . "00";
$eutme = $edate . "23";
&read_db_data;

#
#print "@utmes\n\n";
$string = "@utmes";
print "Check missing data, download and insert to database:\n";
for ($dd=$sdate;$dd<=$edate;$dd++){
	  for ($hr=0;$hr<24;$hr++){
	       if ($hr < 10){ $ddate = $dd . "0$hr"; }
         else { $ddate = $dd . $hr; }
         
         if ($string !~ /$ddate/){ 
         	   #print "$ddate\n"; 
         	   print "$ddate...";
         	   $command =  "/data/ldm/data/kymesonet/scripts/kymesonet_date.pl " . "$ddate" . "0500";
         	   #print "$command\n";
         	   system("$command");
         	   print "...done.\n";
         	   sleep 8;
         	   }
         #print "$ddate\n";
    }
	

}

#

##


# Check data in the database
sub read_db_data
{

$dsn = "DBI:mSQL:$database";

$con = DBI->connect($dsn) ||
    die "Unable to connect $database:$DBI::errstr ";
	
$query = "select utme from $tbname where utme>=$sutme and utme<=$eutme order by utme";
$sth = $con -> prepare($query);
$sth->execute;

while ( $row = $sth->fetchrow_array ) {
        #print "$row\n";
        push(@utmes,$row);
}

#@query_out = $sth->fetchrow_array;
$sth->finish;

$con ->disconnect;
	
}	

#
sub read_kym_sites
{
$kym_sites = "/data/ldm/data/kymesonet/scripts/kymesonet_sites";

open (INFILE,"$kym_sites");

$line = <INFILE>;

while (!eof(INFILE)) {
    $line = <INFILE>;
    chomp($line);

    ($co,$site,$tm) = split(/\s+/,$line);
    #print "$co,$site,$tm\n";

    push(@sites,$site);
    $timezones{$site} = $tm;

    #print "$site,$timezones{$site}\n\n";

}

close(INFILE);

}
