#!/usr/bin/perl -w
#  this script read kymesonet daily data from kymesonet database 
#  WH Wang,20101012
use DBI();
$database = "kymesonet";
$tbname = "kymn_dl";
$dsn = "DBI:mSQL:$database";

$sdir = "/data/ldm/data/kymesonet/scripts";

if ($ARGV[0] && $ARGV[1]){ 
	  $sdate = $ARGV[0]; chomp($sdate);
	  $edate = $ARGV[1]; chomp($edate);
	 }
else { print "Missing input, please run:\n";
	     print "To read all sites:./create_grads_data_date.pl start_date end_date\n";    
	     print "To read  one site:./create_grads_data_date.pl start_date end_date SITE\n";     
	     print "For example: start_date:20101001,  end_date:20101020, SITE:CMBA\n\n";
	     #print "./create_grads_data_date.pl 20080101 20080131\n";
	     #print " .OR. \n";
	     #print "./create_grads_data_date.pl 20080101 20080131 CMBA\n";
	     exit;
}

# 
$con = DBI->connect($dsn) ||
    die "Unable to connect $database $tbname:$DBI::errstr ";

#
#&read_kym_sites;

if ($ARGV[2]) { 
	  $sitein = $ARGV[2]; 
	  chomp($sitein);     
    $site = $sitein;
    #push(@sites,$sitein);
    # read db data
    #$query = "select * from $tbname where stid='$site' and (ltme>=$sdate and ltme<=$edate)";
    $query = "select * from $tbname where ltme>=$sdate and ltme<=$edate and stid='$site' order by ltme";
    #$query = "select * from $tbname where stid='$sitein' and ltme=$sdate";
    print "$query\n";
    &read_kym_sites;
    &read_DB_data;
}else{ 
	    &read_kym_sites;
	    &read_all_sites; 
}

#
$con ->disconnect;


##

# read all sites date daily
sub read_all_sites
{


# Julian date for Starting date
$year = substr($sdate,0,4);
$month = substr($sdate,4,2);
$day = substr($sdate,6,2);
#print "$year$month$day\n";
$jdates = date_to_julian($year, $month, $day);

# Julian date for End date
$year = substr($edate,0,4);
$month = substr($edate,4,2);
$day = substr($edate,6,2);
#print "$year$month$day\n";
$jdaten = date_to_julian($year, $month, $day);

print "start day: $sdate, Julian date:$jdates\n";
print "end day: $edate, Julian date:$jdaten\n\n";

for ($dd=$jdates;$dd<=$jdaten;$dd++){         
    # Convert Julian day to date
    if ($dd == $jdates){ $date1 = $sdate; }
    elsif ($dd == $jdaten){ $date1 = $edate; }
    else{
        $jdate = $dd;
        @ddate1 = julian_to_date($jdate);
        if ($ddate1[1]<10) {$ddate1[1] = "0" . $ddate1[1]};
        if ($ddate1[2]<10) {$ddate1[2] = "0" . $ddate1[2]};
        $date1 = $ddate1[0] . $ddate1[1] . $ddate1[2];
    }
    print "The current day is: $date1\n";
    #print "The current day is: $date1, Julian date: $jdate \n";
    
    foreach $site(@sites){
        $query = "select * from $tbname where stid='$site' and ltme=$date1";
        &read_DB_data;
    }
    sleep 10

} # end for loop
		
}	


#
sub IsLeapYear
{
   my $year = shift;
   return 0 if $year % 4;
   return 1 if $year % 100;
   return 0 if $year % 400;
   return 1;
}


# Convert from Date to Julian Date
# input: year, month, day     output: julian_date
# Using: $jdate=date_to_julian($year, $month, $day)

sub date_to_julian {
use integer;

return $day - 32075
+ 1461 * ( $year + 4800 - ( 14 - $month ) / 12 ) / 4
+ 367 * ( $month - 2 + ( ( 14 - $month ) / 12 ) * 12 ) / 12
- 3 * ( ( $year + 4900 - ( 14 - $month ) / 12 ) / 100 ) / 4;
}



# Convert julian day to year, month and day
# input: julian_date       output: year, month, day
#

sub julian_to_date {
use integer;

$jdate_tmp = $jdate - 1721119;
$yy1 = (4 * $jdate_tmp - 1) / 146097;
$jdate_tmp = 4 * $jdate_tmp - 1 - 146097 * $yy1;
$dd1 = $jdate_tmp/4;
$jdate_tmp = (4 * $dd1 + 3)/1461;
$dd1 = 4 * $dd1 + 3 - 1461 * $jdate_tmp;
$dd1 = ($dd1 + 4)/4;
$mm1 = (5 * $dd1 - 3) / 153;
$dd1 = 5 * $dd1 - 3 - 153 * $mm1;
$dd1 = ($dd1 + 5) / 5;
$yy1 = 100 * $yy1 + $jdate_tmp;
if ($mm1 < 10) {
$mm1 += 3;
} else {
$mm1 -= 9;
++$yy1;
}

return ($yy1, $mm1, $dd1);
}

#
#
sub read_kym_sites
{
$kym_sites = "/data/ldm/data/kymesonet/scripts/kymesonet_sites";

open (INFILE,"$kym_sites");

$line = <INFILE>;

while (!eof(INFILE)) {
    $line = <INFILE>;
    chomp($line);

    ($co,$site,$tm,$lat,$lon,$start,$loc) = split(/\s+/,$line);
    #print "$co,$site,$tm\n";
    $timezones{$site} = $tm;
    $counties{$site} = $co;
    $lats{$site} = $lat;
    $lons{$site} = $lon;
    $starts{$site} = $start;
    $locs{$site} = $loc;

    if ($ARGV[2] && $sitein eq $site) { 
        @sites = "$site";        
        last;
    } else {
    push(@sites,$site);
    }
  

    #print "$site,$timezones{$site}\n\n";

}

close(INFILE);

}

#
sub read_DB_data
{

#$query = "select * from $tbname where stid='$site' and ltme=$date";
$sth = $con -> prepare($query);
$sth->execute;

while(@query_out = $sth->fetchrow_array){

    #$site = $query_out[0];
    $ddate = $query_out[1];
    $tmx = $query_out[2];  #$tmx = sprintf("%3d", $tmx);
    $tmn = $query_out[3];  #$rh_mn = sprintf("%3d",$rh_mn);
    $prc = $query_out[4]; 
    $hmx = $query_out[5];  #$rh_mx = sprintf("%3d",$rh_mx);
    $hmn = $query_out[6]; #$rh_mn = sprintf("%3d",$rh_mn);
    $atd = $query_out[7];
    $wsa = $query_out[8];
    $wsx = $query_out[9];
    
    $str = sprintf("%12s",$counties{$site});
    print "$site, $str, $ddate, $tmx, $tmn, $prc, $hmx, $hmn, $atd, $wsa, $wsx\n"; 
    
    #if ($tmx>998||$tmn>998||$hmx>998||$hmn>998||$atd>998||$wsa>999||$wsx>999||$prc<0){   
    #print "$site, $ddate, $tmx, $tmn, $prc, $hmx, $hmn, $atd, $wsa, $wsx\n";  
    #}

}

$sth->finish;


}
