#!/usr/bin/perl -w
use LWP::Simple;
use XML::Simple;
use Data::Dumper;
use DBI();

$xml = new XML::Simple;

$database = "kymesonet";
$dsn = "DBI:mSQL:$database";

$con = DBI->connect($dsn) ||
    die "Unable to connect $database $tbname:$DBI::errstr ";
    
@sites = qw(FARM HTFD PCWN MRHD MRRY RSVL);
#%timezones = ("FARM"->"CST","HTFD"->"CST","PCWN"->"EST","MRHD"->"EST","MRRY"->"CST","RSVL"->"CST");
%timezones = ("FARM","CST","HTFD","CST","PCWN","EST","MRHD","EST","MRRY","CST","RSVL","CST");

#http://partners.kymesonet.org/xmldata/v1.1/rangesummary_xml.php?network=KYMN&site=all&starttime=20080414000000&stoptime=20080414235959
#$url = "http://partners.kymesonet.org/xmldata/v1.1/rangesummary_xml.php?network=KYMN&site=";
$url = "http://partners.kymesonet.org/xmldata/v1.1/rangesummary_xml.php?site=";
#
#if ($ARGV[0]) { $yday = $ARGV[0]; chomp($yday); }
#else { print "Misiing input, please run:./kymesonet_date.pl 20080101\n"; exit; }

$yday = `date --date='yesterday' +%Y%m%d`;
$tday = `date +%Y%m%d`;
chomp($yday);
chomp($tday);

print "$yday\n";

#$starttime = $yday . "000000"; 
#$stoptime = $yday . "235959";

#print "$starttime - $stoptime\n";

foreach $site(@sites){
	
	      $timezone = $timezones{$site};
	      # Change ST to DT
	      &timezone_st2dt;
	      
	      # Calculate UTMC
	      &ltme_to_utmc;
	      $starttime = $yday . $utc_hh . "0000";
	      $stoptime = $tday . $utc_hh1 . "5959";
	      
	      $url1 = $url . $site . "&" ."starttime=$starttime" . "&" . "stoptime=$stoptime"; 
	      print "$url1\n";

        &read_xml_file;
   	   #$doc = get("$url$site");
   	   #print "$doc\n\n";
   	   
   	   #$data = $xml;
       $data = $xml->parse_string($docs);
   	   
   	   &print_data;

       last;
   	
}



# download each site
#&download_each;



#
$con ->disconnect;

##
sub timezone_st2dt
{
# Change time zone if wrong selection out of Daylight Time(in Summer)
#if ($timezone eq "EDT"){ $timezone = "EST"; }
#elsif ($timezone eq "CDT"){ $timezone = "CST"; }
#elsif ($timezone eq "MDT"){ $timezone = "MST"; }
#elsif ($timezone eq "PDT"){ $timezone = "PST"; }   

if ($timezone eq "EST" || $timezone eq "Eastern"){ $timezone = "EDT"; }
elsif ($timezone eq "CST" || $timezone eq "Central"){ $timezone = "CDT"; }
elsif ($timezone eq "MST" || $timezone eq "Mountain"){ $timezone = "MDT"; }
elsif ($timezone eq "PST" || $timezone eq "Pacific"){ $timezone = "PDT"; }   


}

# Converting LTME to UTME
sub ltme_to_utmc
{    
    # UTC Time
    if ($timezone eq "EST"){ $utc_hh = 5; }        # EST Time = UTC -5 hrs                           
    elsif ($timezone eq "EDT"){ $utc_hh = 4; }   	 # EDT Time = UTC -4 hrs               
    elsif ($timezone eq "CST"){ $utc_hh = 6; }     # CST Time = UTC -6 hrs                
    elsif ($timezone eq "CDT"){ $utc_hh = 5; }     # CDT Time = UTC -5 hrs                
    elsif ($timezone eq "MST"){ $utc_hh = 7; }     # MST Time = UTC -7 hrs           	
    elsif ($timezone eq "MDT"){ $utc_hh = 6; }     # MDT Time = UTC -6 hrs                      	
    elsif ($timezone eq "PST"){ $utc_hh = 8; }     # PST Time = UTC -8 hrs        
    elsif ($timezone eq "PDT"){ $utc_hh = 7; }     # PDT Time = UTC -7 hrs                                  	      

   #if ($utc_hh < 10){ $utc_hh = "0" . $utc_hh; } 
   $utc_hh1 = $utc_hh - 1;
	 $utc_hh = "0" . $utc_hh;	 
	 $utc_hh1 = "0" . $utc_hh1;
}

# download each site
sub download_each
{

foreach $site(@sites)
{
  #if ($site eq "FARM"){
   	$doc = get("$url$site");
   	print "doc:\n";
   	print "$doc\n\n";
   	#system("wget $url$site");	
   	#system("mv $site_xml$site $site");
	  #&parse_data1;
	#}
}

}	

# download all sites
sub download_all
{
$xml_head = "<?xml version=\"1.0\"?>";
$obsgroup = "</ObservationGroup>";
$obsb = "<Observations>";
$obse = "</Observations>";

#$url = $url . "ALL";
$obs = get("$url");
#print "obs:\n";
print "$obs:\n\n";

@docs = split(/\n/,$obs);

#print "docs:\n";

$obs = "";

foreach $str(@docs){
	   #print "$str\n";
     $obs .= $str . "\n";
     if ($str =~ /$obsgroup/){
     	   $obs .= $obse . "\n";
     	   #print "$obs\n\n";
     	   &parse_data;
     	   
     	   $obs = $xml_head . "\n";
     	   $obs .= $obsb . "\n";
     	   
     }	
	
}	

}

# 
sub read_xml_file
{

$sfile = $site . "." . "080414";
print "Read XML file: $sfile\n\n";

open (INFILE,"$sfile");

$docs = "";

while (!eof(INFILE)) {
    $line = <INFILE>;
    if ($line =~ /version/){ $line =~ s/^\s+//; }
    #if ($line =~ /RangeSummary/||$line =~ /RangeSummaries/){ $line =~ s/-/$1/g;; }
    if ($line =~ /RangeSummary/||$line =~ /RangeSummaries/){ $line =~ s/^-//g; }
    
    
    
    $docs .= $line;
    
}
	
close(INFILE);	

print "$docs\n";
	
}	


# Parsing and bulding msql string
sub parse_data
{
# read XML file
#$data = $xml;
$data = $xml->parse_string($obs);

#&print_data;

$stid = $data->{ObservationGroup}->{STID};
if (!$stid){ return; }
# UTME:2008-02-15 10:10:00
$utme = $data->{ObservationGroup}->{UTME}->{content};
if (!$utme){ return; }
@str = $utme =~ /(\d+)/g; 
$utme = "$str[0]$str[1]$str[2]$str[3]";

# LTME:2008-02-15 10:10:00
$ltme = $data->{ObservationGroup}->{LTME}->{content};
if (!$utme){ return; }
@str = $ltme =~ /(\d+)/g; 
$ltme = "$str[0]$str[1]$str[2]$str[3]";

#($s1,$s2) = split(/\s+/,$ltme);
# TAIR:9.14 C to F
$tair = $data->{ObservationGroup}->{TAIR}->{content};
if (!$tair){ $tair = 999.9; }
else { $tair = 32 + 1.8 * $tair;  }
$tair = sprintf("%5.1f",$tair);

# converting mm to inch
$dprc = $data->{ObservationGroup}->{DPRC}->{content};
if ($dprc eq ""){ $dprc = -1.0; }
else { $dprc = 0.03937 * $dprc; }
$dprc = sprintf("%4.2f",$dprc);

$relh = $data->{ObservationGroup}->{RELH}->{content};
if (!$relh){ $relh  = 999; }
$relh = sprintf("%5.0f",$relh);

# converting mm to inch
$tdpt = $data->{ObservationGroup}->{TDPT}->{content};
if (!$tdpt){ $tdpt = 999.9; }
else { $tdpt = 32 + 1.8 * $tdpt; }
$tdpt = sprintf("%5.1f",$tdpt);

# converting meter/s to mile/h
$wspd = $data->{ObservationGroup}->{WSPD}->{content};
if (!$wspd){ $wspd = 999.9; }
else { $wspd = 2.23694 * $wspd; }
$wspd = sprintf("%5.1f",$wspd); 

$wdir = $data->{ObservationGroup}->{WDIR}->{content};
#if ($wdir eq ""){ $wdir = 999; }
if (!$wdir){ $wdir = 999; }
$wdir = sprintf("%5.0f",$wdir);

#converting meter/s to mile/h
$wsmx = $data->{ObservationGroup}->{WSMX}->{content};
if (!$wsmx){ $wsmx = 999.9; }
else { $wsmx = 2.23694 * $wsmx; }
$wsmx = sprintf("%5.1f",$wsmx); 

$srad = $data->{ObservationGroup}->{SRAD}->{content};
if (!$srad){ $srad = -1.0; }
$srad = sprintf("%6.1f",$srad);
#print "$stid,$ltme,$tair,$dprc,$relh,$tdpt,$wspd,$wdir,$wsmx,$srad\n";

# Insert to db "kymesonet" 
$tbname = $stid . "_H";
&check_db_data;
if (!@query_out) { 
  	&insert_db; 
}

}

# Check data in the database
sub check_db_data
{
	
$query = "select * from $tbname where ltme=$ltme";
$sth = $con -> prepare($query);
$sth->execute;

@query_out = $sth->fetchrow_array;
$sth->finish;
	
}	


# Insert data to msql db
sub insert_db
{
#$tbname = $stid . "_H";

$query = "insert into $tbname values \(";
$query .= sprintf("%10s,",$utme);
$query .= sprintf("%10s,",$ltme);
$query .= sprintf("%6s,",$tair);
$query .= sprintf("%6s,",$dprc);
$query .= sprintf("%4s,",$relh);
$query .= sprintf("%6s,",$tdpt);
$query .= sprintf("%6s,",$wspd);
$query .= sprintf("%4s,",$wdir);
$query .= sprintf("%6s,",$wsmx);
$query .= sprintf("%8s",$srad);

$query .= "\)";

print "$query\n";

$cursor = $con->do($query);

}

sub print_data
{

# print output
print "dump data:\n";
print Dumper($data);
print "\n:";
# access XML data

print "STID:$data->{RangeSummary}->{STID}\n";
print "XTMX:$data->{RangeSummary}->{XTMX}->{content}\n";
print "XTMN:$data->{RangeSummary}->{XTMN}->{content}\n";
print "XHMX:$data->{RangeSummary}->{XHMX}->{content}\n";
print "XHMN:$data->{RangeSummary}->{XHMN}->{content}\n";
print "XATD:$data->{RangeSummary}->{XATD}->{content}\n";
print "XPRC:$data->{RangeSummary}->{XPRC}->{content}\n";
print "XWSA:$data->{RangeSummary}->{XWSA}->{content}\n";
print "XWSX:$data->{RangeSummary}->{XWSX}->{content}\n";

print "\n";
	

}
	
#Remov leading or ending whitespace of a string
#$string = trim($string);
#@many   = trim(@many);
sub trim {
    @out = @_;
    for (@out) {
        s/^\s+//;
        s/\s+$//;
    }
    return wantarray ? @out : $out[0];
}
